<?php
/*
Plugin Name: Category Thumbnail List
Plugin URI: http://jonk.pirateboy.net/blog/category/bloggeriet/wordpress/plugins/
Description: Creates a list of thumbnail images, using the_post_thumbnail() in WordPress 2.9 and up.
Version: 0.2
Author: Jonk
Author URI: http://jonk.pirateboy.net
*/
$categoryThumbnailList_Path = get_option('siteurl')."/wp-content/plugins/categoy-thumbnail-list/";

define("categoryThumbnailList_REGEXP", "/\[categorythumbnaillist ([[:print:]]+)\]/");

define("categoryThumbnailList_TARGET", "###CATTHMBLST###");

function categoryThumbnailList_callback($listCatId) {
	global $post;
	$tmp_post = $post;
	$myposts = get_posts('category='.$listCatId[1]);
	$output = '<div class="categoryThumbnailList">';
	foreach($myposts as $post) :
		setup_postdata($post);
		if ( has_post_thumbnail() ) {
		$link = get_permalink($post->ID);
		$thmb = get_the_post_thumbnail($post->ID,'thumbnail');
		$title = get_the_title();
		$output .= '<div class="categoryThumbnailList_item">';
			$output .= '<a href="' .$link . '" title="' .$title . '">' .$thmb . '</a><br/>';
			$output .= '<a href="' .$link . '" title="' .$title . '">' .$title . '</a>';
		$output .= '</div>';
		}
	endforeach;
	$output .= '</div>';
	$output .= '<div class="categoryThumbnailList_clearer"></div>';
	return ($output);
	$output = '';
	$post = $tmp_post;
	setup_postdata($post);
}

function categoryThumbnailList($content) {
	return (preg_replace_callback(categoryThumbnailList_REGEXP, 'categoryThumbnailList_callback', $content));
}

function categoryThumbnailList_css() {
	global $categoryThumbnailList_Path;
	echo "
<style type=\"text/css\">
	@import url(\"".$categoryThumbnailList_Path."categoy-thumbnail-list.css\");
</style>
";
}

add_action('wp_head', 'categoryThumbnailList_css');
add_filter('the_content', 'categoryThumbnailList',1);
?>
